/*
	usb card reader TCP service helper functions
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <strings.h>
#include <string.h>
#include <errno.h>
#include <sys/wait.h>
#include <signal.h>
#include <fcntl.h>
#include <termio.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

static int tcpPort[2];
static int sockfd[2];

static char databuf[2][127];

int cardUSBConnect(int rdr, int port, char *ip)
{
	char ipAddress[127];
	struct sockaddr_in localAddr, servAddr;
	struct hostent *h;
	int rc;
	char s[80];

	tcpPort[rdr] = port;
	strcpy(ipAddress, ip);

	h = gethostbyname(ipAddress);
	if (h==NULL)
	{
		cerror("Card Reader unknown host");
		return 0;
	}
	servAddr.sin_family = h->h_addrtype;
	memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0], h->h_length);
	servAddr.sin_port = htons(tcpPort[rdr]);

	/* create socket */
	sockfd[rdr] = socket(AF_INET, SOCK_STREAM, 0);
	if (sockfd[rdr]<0)
	{
		cerror("Card Reader cannot open socket ");
		return 0;
	}

	/* bind any port number */
	localAddr.sin_family = AF_INET;
	localAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	localAddr.sin_port = htons(0);
	
	rc = bind(sockfd[rdr], (struct sockaddr *) &localAddr, sizeof(localAddr));
	if (rc<0)
	{
		sprintf(s, "Card Reader %s: cannot bind port TCP %u\n", ipAddress, tcpPort[2]);
		cerror(s);
		close(sockfd[rdr]);
		return 0;
	}
				
	/* connect to server */
	rc = connect(sockfd[rdr], (struct sockaddr *) &servAddr, sizeof(servAddr));
	if (rc<0)
	{
		cerror("Card Reader cannot connect ");
		close(sockfd[rdr]);
		return 0;
	}
	return 1;
}

void cardUSBDisconnect(int rdr)
{
	shutdown(sockfd[rdr], 2);
	close(sockfd[rdr]);
}

static int myrecv(int rdr, unsigned char *rbuf, int cnt)
{
	char s[60];
	unsigned char resp[2];
	int i;

	for (i = 0; i < cnt; i++)
	{
		if (recv(sockfd[rdr], resp, 1, 0))
		{
			*rbuf++ = resp[0];
			if (resp[0] == '\n')
				break;
		}
		else
		{
			sprintf(s, "No response from Card Reader #%d", rdr + 1);
			cerror(s);
			return 0;
		}
	}
	*rbuf = '\0';

	return 1;
}

char *cardUSBRead(int rdr)
{
	char buf[32];
	char *Result;

	Result = NULL;
	strcpy(buf, "\r");
	send(sockfd[rdr], buf, strlen(buf), 0);
	myrecv(rdr, (unsigned char *) databuf[rdr], 30);
	if (databuf[rdr][0] == ';' && strlen(databuf[rdr]) >= 7)
	{
		databuf[rdr][strlen(databuf[rdr]) - 2] = '\0';	// null terminate the time field
		Result = databuf[rdr] + 4;
	}

	return Result;
}


